From 20fa62bf715d0915622525660266b3d8edc7e07e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 16 2020 01:34:05 +0000
Subject: [PATCH 1416/2232] Enforce opaque Rust types are unpin for now


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index bb93589..94c5696 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -489,10 +489,14 @@ fn expand_rust_type_assert_sized(ety: &ExternType) -> TokenStream {
     let sized = quote_spanned! {ety.semi_token.span=>
         #begin_span std::marker::Sized
     };
+    let unpin = quote_spanned! {ety.semi_token.span=>
+        #begin_span std::marker::Unpin
+    };
     quote_spanned! {ident.span()=>
         let _ = {
             fn __AssertSized<T: ?#sized + #sized>() {}
-            __AssertSized::<#ident>
+            fn __AssertUnpin<T: #unpin>() {}
+            (__AssertSized::<#ident>, __AssertUnpin::<#ident>)
         };
     }
 }
diff --git a/tests/ui/rust_pinned.stderr b/tests/ui/rust_pinned.stderr
new file mode 100644
index 0000000..f16f9d5
--- /dev/null
+++ b/tests/ui/rust_pinned.stderr
@@ -0,0 +1,10 @@
+error[E0277]: `PhantomPinned` cannot be unpinned
+ --> $DIR/rust_pinned.rs:6:14
+  |
+6 |         type Pinned;
+  |         -----^^^^^^-
+  |         |    |
+  |         |    within `Pinned`, the trait `Unpin` is not implemented for `PhantomPinned`
+  |         required by this bound in `__AssertUnpin`
+  |
+  = note: required because it appears within the type `Pinned`

